﻿using Syncfusion.Drawing;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Tables;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using System.Reflection;
using Syncfusion.Pdf.Graphics;

namespace PdfTableCreation
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            GeneratePDF.Clicked+=GeneratePDF_Clicked;
        }

        private void GeneratePDF_Clicked(object sender, EventArgs e)
        {
            PdfDocument document = new PdfDocument();
            PdfPage page = document.Pages.Add();

            PdfLightTable table = new PdfLightTable();
            // Set the DataSourceType as Direct
            table.DataSourceType = PdfLightTableDataSourceType.TableDirect;
            table.Style.DefaultStyle.BorderPen = new Syncfusion.Pdf.Graphics.PdfPen(Syncfusion.Drawing.Color.Red);
            // Creating Columns

			table.Columns.Add(new PdfColumn("Roll Number") { Width = 80 });

			// Adding Rows
			table.Rows.Add(new string[] { "This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text. "});

			// Adding Rows
			table.Rows.Add(new string[] { "This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text." +
				" This is a very long text. This is a very long text. This is a very long text. "});

			// Adding Rows
			table.Rows.Add(new string[] { "Pdf light table testing" });

			// Adding Rows
			table.Rows.Add(new string[] { "Pdf light table testing" });

			table.BeginRowLayout += new BeginRowLayoutEventHandler (PdfLightTable_BeginRowLayout);

			table.Draw(page,new RectangleF(0,0,500,500));



            MemoryStream stream = new MemoryStream();

            document.Save(stream);
            document.Close();

            DependencyService.Get<ISave>().SaveTextAsync("Invoice.pdf", "application/pdf", stream);
        }
		void PdfLightTable_BeginRowLayout(object sender, BeginRowLayoutEventArgs args)
		{
			Stream fstreamA = typeof(MainPage).GetTypeInfo ().Assembly.GetManifestResourceStream ("PdfTableCreation.Assets.Fonts.Courier.ttf");
			Stream fstreamB = typeof(MainPage).GetTypeInfo ().Assembly.GetManifestResourceStream ("PdfTableCreation.Assets.Fonts.Helvetica.ttf");

			PdfTrueTypeFont fontA = new PdfTrueTypeFont (fstreamA, 8);
			PdfTrueTypeFont fontB = new PdfTrueTypeFont (fstreamB, 10);

			PdfCellStyle style = new PdfCellStyle ();

			if (args.RowIndex % 2 == 0) {
				style.Font = fontA;
			} else {
				style.Font = fontB;
			}

			style.StringFormat = new PdfStringFormat (PdfTextAlignment.Left, PdfVerticalAlignment.Bottom);
			args.CellStyle = style;
			args.MinimalHeight = 18;
		}
    }
}
